// StarPong v 0.95b (c) 1998 Graham Mitchell <mitchell@onr.com> - 22 Nov 1998

// colortab.cpp
// little util to display current palette

/*
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License (LICENSE.TXT) for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <allegro.h>
#include <stdlib.h>
#include "palette.h"


int main()
{
	allegro_init();
	install_keyboard();

	BITMAP *buffer;
	PALETTE pal;
	set_color_depth(8);
	set_gfx_mode(GFX_VGA, 320, 200, 0, 0);
	mkpal(pal);
	set_palette(pal);

	clear(screen);
	buffer = create_bitmap(SCREEN_W, SCREEN_H);
	clear(buffer);
	text_mode(-1);

	int x,y,i=0;
	char buf[5] = { 0 };
	const int width = 40;
	const int height = 12;
	const int w = width-1;
	const int h = height-1;
	const int x_slack = 0;
	const int y_slack = 8;
	const int textcolor = 240;

	while ( i < 255 && !key[KEY_ESC] )
	{
		for ( y=0; y<SCREEN_H-y_slack; y+=height )
			for ( x=0; x<SCREEN_W-x_slack && i<=255 ; x+=width )
			{
				rectfill(buffer,x,y,x+w,y+h,i);
				textout(buffer,font,itoa(i,buf,10),x+1,y+1,255);
				++i;
			}
		blit(buffer,screen,0,0,0,0,SCREEN_W,SCREEN_H);
		clear_keybuf();
		while ( !key[KEY_ENTER] && !key[KEY_ESC] )
			;
		clear(buffer);
	}

	destroy_bitmap(buffer);
	allegro_exit();

	return 0;
}

