// StarPong v 0.95b (c) 1998 Graham Mitchell <mitchell@onr.com> - 22 Nov 1998

// paddle.h
// Interface for Paddle class

/*
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License (LICENSE.TXT) for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#ifndef __PONG_PADDLE_H
#define __PONG_PADDLE_H

#include "reduce.h"


class Paddle
{

public:

	Paddle();
	~Paddle();

	void init();
	void set_loc(int x0, int y0) { x=home_x=x0; y=home_y=y0; }
	void set_speed(int s) { speed=s; }
	void set_width(int w) { width=w; }
	void set_length(int l) { length=l; }
	void set_color(int c) { color=c; }
	void set_keys(int u, int d, int l, int r)
		{ K_UP=u; K_DOWN=d; K_LEFT=l; K_RIGHT=r; }
	void set_goal_loc(int x1, int y1, int x2, int y2)
		{ goal.x1=x1; goal.y1=y1; goal.x2=x2; goal.y2=y2; }    
	void set_score_loc(int x, int y)
		{ score_x=x; score_y=y; }
	void set_bbox(int x1, int y1, int x2, int y2)
		{ MIN_X=x1; MIN_Y=y1; MAX_X=x2; MAX_Y=y2; }

	void move();
	void point() { score++; }
	void gohome() { x=home_x; y=home_y; }
	void draw(BITMAP* = screen);

	BBox location();
	BBox goal_loc() { return goal; }
	int  points() { return score; }
	void get_momentum( int& x, int& y ) { x=dx; y=dy; }

private:

	int x,y;
	int dx,dy;
	int home_x, home_y;
	int speed;
	int color, length, width;

	int K_UP, K_LEFT, K_RIGHT, K_DOWN;
	int MIN_X, MAX_X, MIN_Y, MAX_Y;

	int score;

	// bounding box for the scoring zone

	BBox goal;

	int score_x, score_y;

    // and variables to keep track of where I used to be

    BBox old;

    BITMAP* goalbmp;
    int goal_xoffset;
    bool coord_on;

    char str[12];
    char coord[12];

};

#endif

