// StarPong v 0.95b (c) 1998 Graham Mitchell <mitchell@onr.com> - 22 Nov 1998

// palette.cpp
// set current palette (with a couple of options)

/*
	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License (LICENSE.TXT) for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software Foundation,
	Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <allegro.h>

void mkpal(PALETTE pal, int which)
{

	if ( which == 0 )
	{
		int i,d;

		// standard VGA colors
		for ( int r=0; r<6; ++r )
			for ( int g=0; g<6; ++g )
				for ( int b=0; b<6; ++b )
				{
					i = 36*r + 6*g + b;
					pal[i].r = r*12;
					pal[i].g = g*12;
					pal[i].b = b*12;
				}

		// a few solid colors fading to black
		for ( i=216; i<224; ++i )
		{
			d = 223 - i;
			pal[i].r = ((d&0x04)>>2)*63;
			pal[i].g = ((d&0x02)>>1)*63;
			pal[i].b = (d&0x01)*63;
		}

		// and add some smooth greys fading from black to white

		for ( i=224,d=1; i<256; ++i,d+=2 )
			pal[i].r = pal[i].g = pal[i].b = d;
	}
	else
	{
		// a smoothly changing VGA palette
		int c;
		for (c=0; c<64; ++c)
		{
			pal[c].r = c;
			pal[c].g = 0;
			pal[c].b = 0;
		}
		for (c=64; c<128; ++c)
		{
			pal[c].r = 127-c;
			pal[c].g = c-64;
			pal[c].b = 0;
		}
		for (c=128; c<192; ++c)
		{
			pal[c].r = 0;
			pal[c].g = 191-c;
			pal[c].b = c-128;
		}
		for (c=192; c<256; ++c)
		{
			pal[c].r = 0;
			pal[c].g = 0;
			pal[c].b = 255-c;
		}
	}

	return;
}
